;--------------------------------------------------------------------
;pc communication
;--------------------------------------------------------------------

rxcharpc:
inchar:		jnb ri,$
		clr ri
		mov a,sbuf
		ret

txcharpc:
sendchar2pc:	jnb ti,$
		clr ti
		mov sbuf,a
		ret

sendstr2pc:	push acc
		clr a
		movc a,@a+dptr
		jnz $+5
		pop acc
		ret
		call sendchar2pc
		inc dptr
		jmp sendstr2pc+2

;senddec2pc:	push acc
;		mov b,#100
;		div ab
;		jz decpcunder100
;decpcup100:	add a,#'0'
;		call sendchar2pc
;		mov a,b
;		mov b,#10
;		div ab
;decpcup10:	add a,#'0'
;		call sendchar2pc
;decpcunder10:	mov a,b
;		add a,#'0'
;		call sendchar2pc
;		pop acc
;		ret
;decpcunder100:	mov a,b
;		mov b,#10
;		div ab
;		jz decpcunder10
;		jmp decpcup10

sendhex2pc:	push acc
		push acc
		swap a			;higher nibble first
		call htoa
		call sendchar2pc
		pop acc
		call htoa		;then lower nibble
		call sendchar2pc
		pop acc
		ret

;sendswaphex:	push acc
;		push acc
;		anl a,#0fh		;lower nibble first
;		call htoa		;in swap byte
;		call sendchar2pc
;		pop acc
;		anl a,#0f0h		;then higher nibble
;		swap a
;		call htoa
;		call sendchar2pc
;		pop acc
;		ret

printcrlf:	push acc
		mov a,#13
		call sendchar2pc
		mov a,#10
		call sendchar2pc
		pop acc
		ret

;printtab:	mov a,#9
;		call sendchar2pc
;		ret

printbuffascii:	push lengthascii
		mov r0,#bufferbase
		mov a,@r0
		cjne a,#10,pbuffascii1
		call printcrlf
		jmp pbuffascii2
pbuffascii1:	call sendchar2pc
pbuffascii2:	inc r0
		djnz lengthascii,printbuffascii+4
		pop lengthascii
		ret