;--------------------------------------------------------------------
;buffer operation
;memory used:	tmp0, tmp1, ... tmp7
;--------------------------------------------------------------------

;search string on buffer, if founded setb flagfind
search:		push lengthascii
		clr flagfind
		mov a,lengthascii
		jnz $+5
		pop lengthascii
		ret

		inc lengthascii		;trailer compensation
		mov tmp1,#0
		mov r0,#bufferbase
nextsearch:	mov a,@r0
		inc r0
		djnz lengthascii,$+6
		pop lengthascii
		ret

		cjne a,#' ',$+5
		jmp nextsearch
search1:	mov r2,a
		mov r1,#tmp1
		call checkbuffer
		jnc nextsearch
		setb flagfind
		pop lengthascii
		ret

checkbuffer:	mov a,@r1
		inc a
		movc a,@a+dptr
		clr c
		subb a,r2
		jnz buffernope
		inc @r1
		clr a
		movc a,@a+dptr
		clr c
		subb a,@r1
		jz buffermatch
		clr c
		ret
buffernope:	mov @r1,#0
		clr c
		ret
buffermatch:	mov @r1,a
		setb c
		ret

;get hex from buffer
gethexbuff:	mov a,@r0
		inc r0
		call ishex
		jnc gethexbufferr
		call atoh
		swap a
		mov b,a
		mov a,@r0
		inc r0
		call ishex
		jnc gethexbufferr
		call atoh
		orl a,b
		setb c
gethexbufferr:	ret

;rolling tmp buffer tmp0<1<2<3<4<5<6<tmp7<acc
rolltmpbuffer:	mov tmp0,tmp1
		mov tmp1,tmp2
		mov tmp2,tmp3
		mov tmp3,tmp4
		mov tmp4,tmp5
		mov tmp5,tmp6
		mov tmp6,tmp7
		mov tmp7,a
		ret

bufftolower:	push lengthascii
		mov r0,#bufferbase
		mov a,@r0
		call tolower
		mov @r0,a
		inc r0
		djnz lengthascii,bufftolower+4
		pop lengthascii
		ret		